#pragma once

#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "component_action_spawn.h"
#include "../component_game_object.h"

#include "../../entity/play/entity_puff.h"

#define COMPONENT_ACTION_ON_COMBAT_HIDE_PUFF_Z_OFFSET -0.01f

typedef struct ComponentActionOnCombatHide
{
	ECSComponent component;
	u32 spawnID;
	u32 timer;
	u32 timerMax;
	bool isHide;
	bool isChanging;
	bool isUnhiding;
	bool isHiding;
} ComponentActionOnCombatHide;

void component_action_on_combat_hide_init(ComponentActionOnCombatHide* self, ECS* ecs, u32 spawnID, u32 timer);
void component_action_on_combat_hide_tick(ComponentActionOnCombatHide* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ACTION_ON_COMBAT_HIDE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 

			NULL,
			NULL,
			(ECSFunction)component_action_on_combat_hide_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_ACTION_ON_COMBAT_HIDE,
	.size = sizeof(ComponentActionOnCombatHide)
};


