#include "component_action_on_delete_give_redirects.h"

/* DEPENDENCIES: Redirects, ActEntity */
/* On deletion, give redirects to the ID belonging to ActEntity. */

/* Initializes action on delete give redirects component. */
void
component_action_on_delete_give_redirects_init(ComponentActionOnDeleteGiveRedirects* self, u32 value)
{
	self->value = value;
}

/* Ticks aciton on delete give redirects component. */
void
component_action_on_delete_give_redirects_delete(ComponentActionOnDeleteGiveRedirects* self, ECS* ecs)
{
	ComponentActEntity* actEntity;
	ComponentRedirects* redirects;

	actEntity = ecs_component_get(ecs, ECS_COMPONENT_ACT_ENTITY, self->component.id);
	redirects = ecs_component_get(ecs, ECS_COMPONENT_REDIRECTS, actEntity->id);

	redirects->value += self->value;
	redirects->value = MAX(redirects->value, redirects->max);
}
