#include "component_animation_idle.h"

/* Initializes animation idle component. */
void
component_animation_idle_init(ComponentAnimationIdle* self, u32 baseIndex, u32 timer)
{
	self->baseIndex = baseIndex;
	self->timerMax = timer;
	self->timer = self->timerMax;
}

/* Ticks animation idle component. */
void
component_animation_idle_tick(ComponentAnimationIdle* self, ECS* ecs)
{
	ComponentSprite* sprite;

	self->timer--;

	if (self->timer <= 0)
	{
		sprite = ecs_component_get(ecs, ECS_COMPONENT_SPRITE, self->component.id);
		
		self->isAnimate = !self->isAnimate;

		if (self->isAnimate)
			sprite->atlas.index = self->baseIndex + 1;
		else
			sprite->atlas.index = self->baseIndex;

		self->timer = self->timerMax;
	}
}
