#pragma once

#include "ANIMATION_COMMON.h"
#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "../component_sprite.h"

typedef struct ComponentAnimationIdle
{
	ECSComponent component;
	u32 baseIndex;
	s32 timer;
	s32 timerMax;
	bool isAnimate;
} ComponentAnimationIdle;

void component_animation_idle_init(ComponentAnimationIdle* self, u32 baseIndex, u32 timer);
void component_animation_idle_tick(ComponentAnimationIdle* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ANIMATION_IDLE_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			NULL,
			NULL, 
			(ECSFunction)component_animation_idle_tick,
			NULL
		}
	},
	.type = ECS_COMPONENT_ANIMATION_IDLE,
	.size = sizeof(ComponentAnimationIdle)
};
