#include "component_behavior_face_target.h"

/* DEPENDENCIES: Sprite */

/* Sets behavior_face_target component info. */
void
component_behavior_face_target_init(ComponentBehaviorFaceTarget* self, u32 targetID)
{
	self->targetID = targetID;
}

/* Ticks behavior_face_target component. */
void
component_behavior_face_target_tick(ComponentBehaviorFaceTarget* self, ECS* ecs)
{	
	ComponentSprite* sprite;
	ComponentSprite* targetSprite;

	sprite = ecs_component_get(ecs, ECS_COMPONENT_SPRITE, self->component.id);
	targetSprite = ecs_component_get(ecs, ECS_COMPONENT_SPRITE, self->targetID);

	if (sprite->position[0] > targetSprite->position[0])
		sprite->isFlipHorizontal = true;
	else
		sprite->isFlipHorizontal = false;
}
