#pragma once

#include "../../component/entity/component_enemy.h"
#include "../../component/behavior/component_behavior_hop.h"
#include "../../component/behavior/component_behavior_face_target.h"
#include "../../ecs_component.h"
#include "../../component/stat/component_game_entity_type.h"
#include "../../component/animation/component_animation_idle.h"

#define CUPPER_IS_SOLID false
#define CUPPER_IS_BOUNCE false
#define CUPPER_IS_AFFECTED_BY_GRAVITY true
#define CUPPER_BEHAVIOR_HOP_HEIGHT_VELOCITY 10
#define CUPPER_BEHAVIOR_HOP_SPEED 15
#define CUPPER_BEHAVIOR_HOP_TIMER 30
#define CUPPER_VELOCITY_MAX 30
#define CUPPER_HEALTH_MAX 3
#define CUPPER_FRICTION 0.9
#define CUPPER_GOODIE_COUNT 1
#define CUPPER_ANIMATION_IDLE_TIMER 10
#define CUPPER_ANIMATION_IDLE_BASE_INDEX 0

static const ivec2 CUPPER_FRAME_SIZE = {512, 512};
static const ivec2 CUPPER_ATLAS_SIZE = {1, 4};
static const vec2 CUPPER_SIZE = {100.0f, 100.0f};
static const vec2 CUPPER_PHYSICS_SIZE = {75.0f, 25.0f};

void entity_cupper_init(ECS* ecs, u32 id, vec3 position, u32 targetID, u32 level);
