#pragma once

#include "../../component/animation/component_animation_idle.h"
#include "../../component/behavior/component_behavior_chase.h"
#include "../../component/action/component_action_angle.h"
#include "../../component/entity/component_enemy.h"
#include "../../ecs_component.h"
#include "../../component/stat/component_game_entity_type.h"

#define CUSTARPEDO_IS_SOLID false
#define CUSTARPEDO_IS_BOUNCE false
#define CUSTARPEDO_IS_AFFECTED_BY_GRAVITY false
#define CUSTARPEDO_BEHAVIOR_CHASE_SPEED 5
#define CUSTARPEDO_FRICTION 1
#define CUSTARPEDO_VELOCITY_MAX 35
#define CUSTARPEDO_HEALTH_MAX 2
#define CUSTARPEDO_GOODIE_COUNT 1
#define CUSTARPEDO_HEIGHT 30
#define CUSTARPEDO_ANIMATION_IDLE_BASE_INDEX 0
#define CUSTARPEDO_ANIMATION_IDLE_TIMER 5

static const ivec2 CUSTARPEDO_FRAME_SIZE = {512, 512};
static const ivec2 CUSTARPEDO_ATLAS_SIZE = {8, 2};
static const vec2 CUSTARPEDO_SIZE = {150.0f, 150.0f};
static const vec2 CUSTARPEDO_PHYSICS_SIZE = {90.0f, 30.0f};

void entity_custarpedo_init(ECS* ecs, u32 id, vec3 position, u32 targetID, u32 level);
