#pragma once

#include "../../ecs_component.h"
#include "../../component/entity/component_pickup.h"
#include "../../component/action/component_action_on_touch_give_goodies.h"
#include "../../component/stat/component_game_entity_type.h"
#include "../../component/action/component_action_keep_in_rectangle.h"

#define GOODIE_FRICTION 0.95
#define GOODIE_VELOCITY_MAX 50
#define GOODIE_PICKUP_TIME 600
#define GOODIE_PICKUP_FADE_THRESHOLD 60
#define GOODIE_PICKUP_VALUE 1
#define GOODIE_PICKUP_GAME_ENTITY_TYPE GAME_ENTITY_PLAYER

static const vec2 GOODIE_SIZE = {64.0f, 64.0f};
static const ivec2 GOODIE_FRAME_SIZE = {512, 512};
static const ivec2 GOODIE_ATLAS_SIZE = {1, 12};
static const vec2 GOODIE_PHYSICS_SIZE = {60.0f, 20.0f};
static const Rectangle GOODIE_ACTION_KEEP_IN_RECTANGLE = {0.0f, 0.0f, 1920.0f, 1080.0f};

void entity_goodie_init(ECS* ecs, u32 id, vec3 position, vec3 velocity, f32 height);
