#include "entity_puff.h"

/* Initializes a puff entity. */
void
entity_puff_init(ECS* ecs, u32 id, vec3 position, vec2 size)
{
	ComponentActionDeleteOnTimer* actionDeleteOnTimer;
	ComponentAnimationColorChange* animationColorChange;
	ComponentSprite* sprite;

	sprite = ecs_component_add(ecs, ECS_COMPONENT_SPRITE, id);
	actionDeleteOnTimer = ecs_component_add(ecs, ECS_COMPONENT_ACTION_DELETE_ON_TIMER, id);
	animationColorChange = ecs_component_add(ecs, ECS_COMPONENT_ANIMATION_COLOR_CHANGE, id);

	component_sprite_init
	(
		sprite,
		ecs->game->resources.textures[TEXTURE_PUFF],
		size,
		position
	);

	component_action_delete_on_timer_init
	(
		actionDeleteOnTimer,
		ENTITY_PUFF_TIMER
	);

	component_animation_color_change_init
	(
		animationColorChange,
		(f32*)COLOR_TRANSPARENT,
		(f32*)COLOR_OPAQUE,
		ENTITY_PUFF_TIMER,
		ANIMATION_COLOR_CHANGE_MODE_STICK
	);
}
