#include "entity_tutorial_text.h"

/* Initializes a player entity. */
void
entity_tutorial_text_init(ECS* ecs, u32 id, vec3 position, u32 heartID)
{
	ComponentActionDeleteOnTimer* actionDeleteOnTimer;
	ComponentActionDeleteOnHeart* actionDeleteOnHeart;
	ComponentAnimationColorChange* animationColorChange;
	ComponentText* text;
	f32 base;

	text = ecs_component_add(ecs, ECS_COMPONENT_TEXT, id);
	actionDeleteOnTimer = ecs_component_add(ecs, ECS_COMPONENT_ACTION_DELETE_ON_TIMER, id);
	actionDeleteOnHeart = ecs_component_add(ecs, ECS_COMPONENT_ACTION_DELETE_ON_HEART, id);
	animationColorChange = ecs_component_add(ecs, ECS_COMPONENT_ANIMATION_COLOR_CHANGE, id);

	component_text_init
	(
		text,
		&ecs->game->resources.fonts[FONT_TUTORIAL],
		STRING_TUTORIAL_TEXT,
		strlen(STRING_TUTORIAL_TEXT),
		ENTITY_TUTORIAL_TEXT_WRAP,
		position,
		(f32*)TUTORIAL_TEXT_COLOR
	);

	component_action_delete_on_timer_init
	(
		actionDeleteOnTimer,
		ENTITY_TUTORIAL_TEXT_TIMER
	);

	component_action_delete_on_heart_init
	(
		actionDeleteOnHeart,
		heartID
	);

	component_animation_color_change_init
	(
		animationColorChange,
		(f32*)COLOR_TRANSPARENT,
		(f32*)TUTORIAL_TEXT_COLOR,
		ENTITY_TUTORIAL_TEXT_TIMER,
		ANIMATION_COLOR_CHANGE_MODE_STICK
	);
}
