#pragma once

#include "../STATE_COMMON.h"

#include "../../ecs/ecs.h"

#include "../../ecs/entity/play/entity_player.h"
#include "../../ecs/entity/play/entity_goodie_display.h"
#include "../../ecs/entity/play/entity_elemental.h"
#include "../../ecs/entity/play/entity_spawner.h"
#include "../../ecs/entity/play/entity_timer_display.h"
#include "../../ecs/entity/play/entity_combat_timer_display.h"
#include "../../ecs/entity/play/entity_wave_display.h"
#include "../../ecs/entity/play/entity_heart_display.h"
#include "../../ecs/entity/play/entity_wave_timer_display.h"
#include "../../ecs/entity/play/entity_shop_button.h"
#include "../../ecs/entity/play/entity_tutorial_text.h"
#include "../../ecs/entity/entity_cursor.h"
#include "../../ecs/entity/entity_sprite.h"

static const vec3 PLAY_PLAYER_POSITION = {960.0f, 1000.0f, 0.8f};
static const vec3 PLAY_ELEMENTAL_POSITION = {960.0f, 500.0f, 0.8f};
static const vec3 PLAY_TUTORIAL_TEXT_POSITION = {128.0f, 128.0f, 0.05f};

static const vec3 PLAY_OVERLAY_POSITION = {960.0f, 540.0f, 0.09999f};
static const vec3 PLAY_OVERLAY_SIZE = {1920.0f, 1080.0f};

#define PLAY_SHADER_COUNT 2
static const ShaderType PLAY_SHADERS[PLAY_SHADER_COUNT] =
{
	SHADER_TEXTURE_QUAD,
	SHADER_COLOR_QUAD
};

#define PLAY_TEXTURE_COUNT 26
static const TextureType PLAY_TEXTURES[PLAY_TEXTURE_COUNT] =
{
	TEXTURE_STATE_FADE,
	TEXTURE_CURSOR,
	TEXTURE_OVERLAY,
	TEXTURE_ICONS,
	TEXTURE_PUFF,
	TEXTURE_REDIRECT_ARROW,
	TEXTURE_STREAK,
	TEXTURE_STREAK_SQUARE,
	TEXTURE_SHADOW,
	TEXTURE_PLAYER,
	TEXTURE_ELEMENTAL,
	TEXTURE_CUPPER,
	TEXTURE_CHIPPER,
	TEXTURE_CRUMBLER,
	TEXTURE_CUSTARPEDO,
	TEXTURE_EXCORSANT,
	TEXTURE_ROCK_CANDY_MICHEAL,
	TEXTURE_NEAPOLITOTEM,
	TEXTURE_EZ_ACHE,
	TEXTURE_CREPER,
	TEXTURE_GUM_MK_II,
	TEXTURE_SNAKE,
	TEXTURE_CHIP,
	TEXTURE_GUMBALL,
	TEXTURE_BEANIE,
	TEXTURE_GOODIES
};

#define PLAY_FONT_COUNT 6
static const FontType PLAY_FONTS[PLAY_FONT_COUNT] =
{
	FONT_NORMAL,
	FONT_STAT_DISPLAY,
	FONT_DAMAGE_NUMBER,
	FONT_HUD,
	FONT_SHOP,
	FONT_TUTORIAL
};

#define PLAY_SOUND_COUNT 30
static const SoundType PLAY_SOUNDS[PLAY_SOUND_COUNT] = 
{
	SOUND_SELECT,
	SOUND_BLEEP,
	SOUND_SNAKE_SHOOT,
	SOUND_RECALL,
	SOUND_PLAYER_HURT,
	SOUND_PLAYER_KILL,
	SOUND_HURT,
	SOUND_REDIRECT,
	SOUND_LOCK,
	SOUND_UNLOCK,
	SOUND_GOODIE,
	SOUND_GULP,
	SOUND_GROW,
	SOUND_HEART,
	SOUND_UPGRADE,
	SOUND_ERROR,
	SOUND_ALERT,
	SOUND_CUPPER_HOP,
	SOUND_CUPPER_KILL,
	SOUND_CHIPPER_KILL,
	SOUND_CHIP_SHOOT,
	SOUND_CHIP_KILL,
	SOUND_CRUMBLER_WHOOSH,
	SOUND_CRUMBLER_SMASH,
	SOUND_CRUMBLER_KILL,
	SOUND_CUSTARPEDO_FLY,
	SOUND_CUSTARPEDO_KILL,
	SOUND_EXCORSANT_SPIN,
	SOUND_EXCORSANT_KILL,
	SOUND_EZ_ACHE_READY
};

#define PLAY_MUSIC_COUNT 7
static const MusicType PLAY_MUSIC[PLAY_MUSIC_COUNT] =
{
	MUSIC_CALM,
	MUSIC_COMBAT_ONE,
	MUSIC_COMBAT_TWO,
	MUSIC_COMBAT_THREE,
	MUSIC_WAVE_COMPLETE_ONE,
	MUSIC_WAVE_COMPLETE_TWO,
	MUSIC_WAVE_COMPLETE_THREE
};

void play_init(Play* play, State* state);
void play_tick(Play* play);
